/* DEMOVERSION: EASY SCRIPT v.0.0.2

Das Plugin ermglicht, eigene Konsolenbefehle fr bestimmte Funktionen zu erstellen
und den Rechtelevel fr diesen Konsolenbefehl festzulegen.
Die notwendigen Paramater sind vom ausfhrenden Befehl (s.u.) festgelegt.

Eingabe in die 'script.txt':
--------------------------------------------------------
v.0.0.2:
- man kann jetzt einen Konsolenbefehl mehrere ausfhrende Befehle hngen. 
  Das klappt aber z.Z. nur mit Befehlen, die auch den selben Parameter haben!!!
- mit ;WAIT kann man die Ausfhrung einer Befehlskette um X s verzgern
v.0.0.1:
- Konsolenbefehle werden mit einem ':' gekennzeichnet. Danach mit Leerzeichen und Zahl der Accesslevel.
- Der auszufhrende Befehl dieses Konsolenbefehls wird mit ';' gekennzeichnet.
- Die Beschreibung des Befehls kann so darunter eingegeben werden. (Am Besten erst die notwendigen Parameter und dann : Beschreibung)




Folgende ausfhrende Befehle stehen z.Z. zur Verfgung:
--------------------------------------------------------
BEFEHLE		Parameter in Konsole			Beschreibung
;HELP		<1>					zeigt alle registrierten Konsolenbefehle mit Beschreibung und Accesslevel
;SAY		<Nachricht>				einfache Chatnachricht an alle Spieler
;SAY_TO 	<Spieler> <Nachricht>			einfache Chatnachricht an einen Spieler (Adminname wird angezeigt!)
;TSAY		[Farbe opt.] <Nachricht>		(farbige) Nachricht links unten an alle
;CSAY		[Farbe opt.] <Nachricht>		(farbige) Nachricht in der Mitte an alle
;TSAY_TO	<Spieler> <Nachricht>			Nachricht an den Spieler (ohne Adminname, Farbe gelb)
;CSAY_TO	<Spieler> [Farbe opt.] <Nachricht>	(farbige) Nachricht in der Mitte an den Spieleran
;KILL		<Spieler>				ttet den Spieler
;SLAP		<Spieler>				slappt den Spieler
;KICK		<Spieler>				entfernt den Spieler vom Server
;BAN		<Spieler> [Minuten] [ip]		bannt einen Spieler (default:permanent) [wenn man 'ip' eingibt, wird die IP gebannt]
;BURY		<Spieler>				versenkt einen Spieler im Boden
;UNBURY		<Spieler>				graebt den Spieler wieder aus
;GLOW		[Farbe] <Spieler>			lsst einen Spieler in der opt. angegeben Farbe glhen.
;WAIT		[Sekunden]				in einer Befehlskette kann man damit die Ausfhrung in Sekunden (default: 1s) verzgern


ANMERKUNG:
-----------
Als Konsolenbefehle auf KEINEN FALL HL-Commands bzw. Mod-Commands angeben.
Sonst funktionieren diese nmlich nicht mehr. Wenn ihr nmlich ein "say" als Konsolenbefehl nehmen
wrdet, dann knnte niemand mehr chatten, der nicht den angegebenen Accesslevel besitzt.
Zu Beachten gilt auch, dass gewisse Textlngen nicht berschritten werden drfen.
Das gilt besonders fr die Beschreibung des Konsolenbefehls und den Konsolenbefehl selbst!
Es wird zur Zeit noch nicht berprft, ob die Textlngen berschritten werden.

IN PLANUNG:
-----------
Falls es berhaupt Verwendung fr dieses Plugin gibt, dann kommen noch folgende Befehle dazu:
;SAY_CONSOLE	<Spieler>
;EXEC		<Befehl>
;EXECCLIENT	<Spieler> <Befehl>
;EXECTEAM	<1=Terror/2=CT> <Befehl>
;EXECALL	<Befehl>
;PLAY		<Spieler> <Sound>
;REPEAT		<Anzahl> (Soll den nachfolgenden Befehl in der Befehlskette X mal wiederholen)
etc.

In einer erweiterten Funktion wren dann auch mehrere ausfhrende Befehle mit einem Konsolenbefehl mglich.
Desweiteren wre dann in Planung ein ;ON_EVENT, um auf Kill-Event oder Injure Event zu reagieren.

*/

#include <core>
#include <string>
#include <admin>
#include <adminlib>

new AM_VERSION_STRING[] = "0.0.2";


new g_ScriptFile[MAX_TEXT_LENGTH]="addons/adminmod/config/easyscript/script.txt";


/*EXEC - COMMANDS*/
#define MAX_COMMANDS	14
new g_ExecCommands[MAX_COMMANDS][]=	{{"HELP"},{"SAY"},{"SAY_TO"},{"TSAY"},{"CSAY"},
					{"TSAY_TO"},{"CSAY_TO"},{"KILL"},{"SLAP"},{"KICK"},
					{"BAN"},{"BURY"},{"UNBURY"},{"GLOW"}};

					
/*Load Script*/
#define MAX_FUNCTIONS	50
new g_RegFunction[MAX_FUNCTIONS][MAX_COMMAND_LENGTH];
new g_AccessLevel[MAX_FUNCTIONS][MAX_NUMBER_LENGTH];
new g_Description[MAX_FUNCTIONS][MAX_DATA_LENGTH];
new g_reg_function;

#define MAX_COMMANDLINES 100
new g_DoCmd[MAX_COMMANDLINES][MAX_DATA_LENGTH];
new g_count_DoCmd;

public plugin_init() {
	plugin_registerinfo("EASY PLUGIN WRITER","Ausfuehren eigener Funktionen ber SDAL-Text Script",AM_VERSION_STRING);
	read_file();
	return PLUGIN_CONTINUE;
}

read_file(){
	new Data[MAX_DATA_LENGTH];
	new i;
	new iLine;
	iLine=filesize(g_ScriptFile);
	for(i=0;i<=iLine;i++){
		readfile(g_ScriptFile,Data,i,MAX_DATA_LENGTH);
		if(strlen(Data)!=0 && strncmp(Data,"/",1)!=0 && strncmp(Data,"#",1)!=0){
			if(strncmp(Data,":",1)==0){
				g_reg_function++;
				strsep(Data[1]," ",g_RegFunction[g_reg_function],MAX_COMMAND_LENGTH,g_AccessLevel[g_reg_function],MAX_NUMBER_LENGTH);
			}if(strncmp(Data,";",1)==0){
				g_count_DoCmd++;
				snprintf(Data,MAX_DATA_LENGTH,"%i %s",g_reg_function,Data[1]);
				strcpy(g_DoCmd[g_count_DoCmd],Data,MAX_DATA_LENGTH);
			}else{
				strcpy(g_Description[g_reg_function],Data,MAX_DATA_LENGTH);
			}
		}
	}
}


/*COMMAND-HANDLING*/

public plugin_command(HLCommand, HLData, HLUserName, UserIndex){
	new Command[MAX_DATA_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new authlevel;
	new i;
	
	convert_string(HLCommand, Command, MAX_COMMAND_LENGTH);
	convert_string(HLData, Data, MAX_DATA_LENGTH);
	convert_string(HLUserName, User, MAX_NAME_LENGTH);
	
	for(i=1;i<=g_reg_function;i++){
		if(strcmp(Command,g_RegFunction[i])==0){
			authlevel=strtonum(g_AccessLevel[i]);
			if(check_auth(authlevel)){
				if(check_length(Data)){
					exec_commands(i,0,Data,User);
				}
			}else{
				selfmessage("[SDAL-SCRIPT] You are not allowed to execute this command!");
			}
			return PLUGIN_HANDLED;
		}
	}
	return PLUGIN_CONTINUE;
}

wait_cmd(Wait[],iFuncID,iDoCmdID,Data[],User[]){
	new Param[MAX_DATA_LENGTH];
	new iWait;
	iWait=strtonum(Wait);
	if(iWait==0){
		iWait=1;
	}
	snprintf(Param,MAX_DATA_LENGTH,"%i%i%s%s",iFuncID,iDoCmdID,Data,User);
	set_timer("exec_wait",iWait,0,Param);
}
	
public exec_wait(Timer,Repeat,HLName,HLParam) {
	new Param[MAX_DATA_LENGTH];
	new FuncID[MAX_NUMBER_LENGTH];
	new DoCmdID[MAX_NUMBER_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new User[MAX_NAME_LENGTH];
	new iFuncID;
	new iDoCmdID;
	convert_string(HLParam,Param,MAX_DATA_LENGTH);
	strsplit(Param,"",FuncID,MAX_NUMBER_LENGTH,DoCmdID,MAX_NUMBER_LENGTH,Data,MAX_DATA_LENGTH,User,MAX_NAME_LENGTH);
	iFuncID=strtonum(FuncID);
	iDoCmdID=strtonum(DoCmdID);
	exec_commands(iFuncID,iDoCmdID,Data,User);
}

exec_commands(iFuncID,iDoCmdID,Data[],User[]){
	new DoCmd[MAX_DATA_LENGTH];
	new FuncID[MAX_NUMBER_LENGTH];
	new iFunctionID;
	new i;
	new j;
	for(i=iDoCmdID;i<=g_count_DoCmd;i++){
		strbreak(g_DoCmd[i],FuncID,DoCmd,MAX_DATA_LENGTH);
		iFunctionID=strtonum(FuncID);
		if(iFuncID==iFunctionID){
			if(strncmp(DoCmd,"WAIT",4)==0){
				strcpy(DoCmd,DoCmd[5],MAX_DATA_LENGTH);
				wait_cmd(DoCmd,iFuncID,i+1,Data,User);
				return PLUGIN_HANDLED;
			}else{
				for(j=0;j<=MAX_COMMANDS;j++){
					if(strcmp(g_ExecCommands[j],DoCmd)==0){
						switch(j){
							case 0: show_help(User,j);
							case 1: say_all(Data,User,j);
							case 2: say_to(Data,User,j); 
							case 3: tsay(Data,User,j); 
							case 4: csay(Data,User,j); 
							case 5: tsay_to(Data,User,j);
							case 6: csay_to(Data,User,j);
							case 7: kill_p(Data,User,j); 
							case 8: slap_p(Data,User,j);
							case 9: kick_p(Data,User,j); 
							case 10: ban_p(Data,User,j); 
							case 11: bury_p(Data,User,j);
							case 12: unbury_p(Data,User,j);
							case 13: glow_p(Data,User,j);
						}
						break;
					}
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

/*EXECUTE COMMAND-HANDLING*/

show_help(User[],CmdID){
	new Text[MAX_TEXT_LENGTH];
	new i;
	selfmessage("*************************");
	selfmessage("* SDAL-EASY-SCRIPT");
	selfmessage("* (Bitte Konsolenfenster vergroeern!)");
	selfmessage("*************************");
	selfmessage("* Registrierte Funktionen:(Funktion, Beschreibung, (Rechtelevel)");
	for(i=1;i<=g_reg_function;i++){
		snprintf(Text,MAX_TEXT_LENGTH,"* %s %s (%s)",g_RegFunction[i],g_Description[i],g_AccessLevel[i]);
		selfmessage(Text);
		strinit(Text);
	}
	say_command(User,g_ExecCommands[CmdID],"");
	return PLUGIN_HANDLED;
}

say_all(Data[],User[],CmdID){
	say(Data);
	say_command(User,g_ExecCommands[CmdID],Data);
	return 1;
}

say_to(Data[],User[],CmdID){
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	strbreak(Data,Player,Text,MAX_DATA_LENGTH);
	if(player_available(Player)){
		snprintf(Text,MAX_TEXT_LENGTH,"%s :%s",User,Text);
		messageex(Player,Text,print_chat);
	}
	say_command(User,g_ExecCommands[CmdID],Data);
}

tsay(Data[],User[],CmdID){
	new Text[MAX_TEXT_LENGTH];
	new iRed;
	new iGreen;
	new iBlue;
	get_color(Data,Text,iRed,iGreen,iBlue);
	typesay(Text,12,iRed,iGreen,iBlue);
	say_command(User,g_ExecCommands[CmdID],Data);
}

csay(Data[],User[],CmdID){
	new Text[MAX_TEXT_LENGTH];
	new iRed;
	new iGreen;
	new iBlue;
	get_color(Data,Text,iRed,iGreen,iBlue);
	centersay(Text,12,iRed,iGreen,iBlue);
	say_command(User,g_ExecCommands[CmdID],Data);
}

tsay_to(Data[],User[],CmdID){
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	strbreak(Data,Player,Text,MAX_DATA_LENGTH);
	if(player_available(Player)){
		messageex(Player,Text,print_tty);
	}
	say_command(User,g_ExecCommands[CmdID],Data);
}

csay_to(Data[],User[],CmdID){
	new Text[MAX_TEXT_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new iRed;
	new iGreen;
	new iBlue;
	strbreak(Data,Player,Text,MAX_DATA_LENGTH);
	if(player_available(Player)){
		get_color(Text,Text,iRed,iGreen,iBlue);
		centersayex(Player,Text,12,iRed,iGreen,iBlue);
	}
	say_command(User,g_ExecCommands[CmdID],Data);
}

kill_p(Player[],User[],CmdID){
	if(player_available(Player)){
		if(!is_immunity(Player)){
			if(is_alive(Player)){
				slay(Player);
			}
		}
	}
	say_command(User,g_ExecCommands[CmdID],Player);
}

slap_p(Player[],User[],CmdID){
	if(player_available(Player)){
		if(!is_immunity(Player)){
			if(is_alive(Player)){
				slap(Player);
			}
		}
	}
	say_command(User,g_ExecCommands[CmdID],Player);
}

kick_p(Player[],User[],CmdID){
	if(player_available(Player)){
		if(!is_immunity(Player)){
			kick(Player);
		}
	}
	say_command(User,g_ExecCommands[CmdID],Player);
}

ban_p(Data[],User[],CmdID){
	new Player[MAX_NAME_LENGTH];
	new sTime[MAX_NUMBER_LENGTH];
	new sBanType[MAX_NAME_LENGTH];
	new iBanType = bBanByID;
	new iTime;
	strbreak(Data,Player,sTime,MAX_DATA_LENGTH);
	strbreak(sTime,sTime,sBanType,MAX_DATA_LENGTH);
	if(player_available(Player)){
		if(!is_immunity(Player)){
			if((strcasecmp(sBanType, "ip")==0) || (getvar("sv_lan") != 0)){
				 iBanType = bBanByIP;
			}
			iTime=strtonum(sTime);
			ban(Player,iTime,iBanType);
		}
	}
	say_command(User,g_ExecCommands[CmdID],Data);
}

bury_p(Player[],User[],CmdID){
	if(player_available(Player)){
		if(!is_immunity(Player)){
			if(is_alive(Player)){
				new x,y,z;
				get_userorigin(Player, x, y, z);
				teleport(Player, x, y, (z-25));
				execclient(Player, "say Heeelp! I am burried!");
			}
		}
	}
	say_command(User,g_ExecCommands[CmdID],Player);
}

unbury_p(Player[],User[],CmdID){
	if(player_available(Player)){
		if(!is_immunity(Player)){
			if(is_alive(Player)){
				new x,y,z;
				get_userorigin(Player, x, y, z);
				teleport(Player, x, y, (z+30));
				execclient(Player, "say Free! I feel free!");
			}
		}
	}
	say_command(User,g_ExecCommands[CmdID],Player);
}

glow_p(Data[],User[],CmdID){
	new Player[MAX_NAME_LENGTH];
	new iRed;
	new iGreen;
	new iBlue;
	get_color(Data,Player,iRed,iGreen,iBlue);
	if(player_available(Player)){
		if(!is_immunity(Player)){
			glow(Player,iRed,iGreen,iBlue);
		}
	}
	say_command(User,g_ExecCommands[CmdID],Data);
}

/*HELPER-FUNCTIONS*/
check_length(Data[]){
	if(strlen(Data)!=0){
		return 1;
	}else{
		selfmessage("[SDAL-SCRIPT] You must enter something!");
	}
	return 0;
}

get_color(Data[],Text[],&iRed,&iGreen,&iBlue){
	new Msg[MAX_TEXT_LENGTH];
	new Color[MAX_NAME_LENGTH];
	strbreak(Data,Color,Msg,MAX_DATA_LENGTH);
	if (streq(Color,"red")==1) {
		iRed=250;
		iGreen=10;
		iBlue=10;
	} else if ( streq(Color, "blue")==1) {
		iRed=10;
		iGreen=10;
		iBlue=250;
	} else if ( streq(Color, "green")==1) {
		iRed=10;
		iGreen=250;
		iBlue=10;
	} else if ( streq(Color, "white")==1) {
		iRed=250;
		iGreen=250;
		iBlue=250;
	} else if ( streq(Color, "yellow")==1) {
		iRed=250;
		iGreen=250;
		iBlue=10;
	} else if ( streq(Color, "purple")==1) {
		iRed=250;
		iGreen=10;
		iBlue=250;
	} else if ( streq(Color, "random")==1) {
		iRed=random(100);
		iGreen=random(100);
		iBlue=random(100);
	} 
	if(iRed!=0){
		strcpy(Text,Msg,MAX_TEXT_LENGTH);
	}else{
		iRed=220;
		iGreen=220;
		iBlue=220;
		strcpy(Text,Data,MAX_TEXT_LENGTH);
	}
}

player_available(Player[]){
	if (check_user(Player)){
		get_username(Player,Player,MAX_NAME_LENGTH);
		return 1;
	}else{
		selfmessage("[SDAL-SCRIPT] Player is not available!");
	}
	return 0;
}

is_immunity(Player[]){
	new Text[MAX_TEXT_LENGTH];
	if(check_immunity(Player)) {
		snprintf(Text, MAX_TEXT_LENGTH, "[SDAL-SCRIPT] LOL. '%s' is immune, you silly bear.", Player);
		selfmessage(Text);
		return 1;
	}
	return 0;
}

is_alive(Player[]){
	new UID;
	new iDead;
	get_userindex(Player,UID);
	if(playerinfo(UID,Player,MAX_NAME_LENGTH,_,_,_,iDead)){
		if(!iDead){
			return 1;
		}else{
			selfmessage("[SDAL-SCRIPT] Player is dead!");
		}
	}
	return 0;
}